<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>angular-frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	   <link rel="stylesheet" href="../styles/style.css">
        <link rel="stylesheet" href="../styles/dark.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">angular-frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content class">
                   <div class="content-data">












<ol class="breadcrumb">
  <li>Classes</li>
  <li >ProjectsDataSource</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts</code>
        </p>




            <p class="comment">
                <h3>Implements</h3>
            </p>
            <p class="comment">
                        <code>DataSource</code>
            </p>


            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#loading$" >loading$</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#loadingSubject" >loadingSubject</a>
                            </li>
                            <li>
                                <a href="#projects" >projects</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#projectsSubject" >projectsSubject</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#connect" >connect</a>
                            </li>
                            <li>
                                <a href="#disconnect" >disconnect</a>
                            </li>
                            <li>
                                <a href="#getAllProjects" >getAllProjects</a>
                            </li>
                            <li>
                                <a href="#loadProjects" >loadProjects</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#log" >log</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(projectService: <a href="../injectables/ProjectAppService.html" target="_self">ProjectAppService</a>, messageService: <a href="../injectables/MessageService.html" target="_self">MessageService</a>)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="106" class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:106</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>projectService</td>
                                                  
                                                        <td>
                                                                        <code><a href="../injectables/ProjectAppService.html" target="_self" >ProjectAppService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>messageService</td>
                                                  
                                                        <td>
                                                                        <code><a href="../injectables/MessageService.html" target="_self" >MessageService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section>
    
    <h3 id="inputs">
        Properties
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="loading$"></a>
                    <span class="name">
                            <span class="modifier">Public</span>
                        <span ><b>loading$</b></span>
                        <a href="#loading$"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Default value : </i><code>this.loadingSubject.asObservable()</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="106" class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:106</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="loadingSubject"></a>
                    <span class="name">
                            <span class="modifier">Private</span>
                        <span ><b>loadingSubject</b></span>
                        <a href="#loadingSubject"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Default value : </i><code>new BehaviorSubject&lt;boolean&gt;(false)</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="103" class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:103</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="projects"></a>
                    <span class="name">
                        <span ><b>projects</b></span>
                        <a href="#projects"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Type : </i>        <code><a href="../interfaces/Project.html" target="_self" >Project[]</a></code>

                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Default value : </i><code>[]</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="104" class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:104</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="projectsSubject"></a>
                    <span class="name">
                            <span class="modifier">Private</span>
                        <span ><b>projectsSubject</b></span>
                        <a href="#projectsSubject"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Default value : </i><code>new BehaviorSubject&lt;Project[]&gt;([])</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="102" class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:102</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
</section>

            <section>
    
    <h3 id="methods">
        Methods
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="connect"></a>
                    <span class="name">
                        <span ><b>connect</b></span>
                        <a href="#connect"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>connect(collectionViewer: CollectionViewer)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="113"
                            class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:113</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>collectionViewer</td>
                                    <td>
                                            <code>CollectionViewer</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="../interfaces/Project.html" target="_self" >Observable&lt;Project[]&gt;</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="disconnect"></a>
                    <span class="name">
                        <span ><b>disconnect</b></span>
                        <a href="#disconnect"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>disconnect(collectionViewer: CollectionViewer)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="117"
                            class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:117</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>collectionViewer</td>
                                    <td>
                                            <code>CollectionViewer</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="getAllProjects"></a>
                    <span class="name">
                        <span ><b>getAllProjects</b></span>
                        <a href="#getAllProjects"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>getAllProjects()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="153"
                            class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:153</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="loadProjects"></a>
                    <span class="name">
                        <span ><b>loadProjects</b></span>
                        <a href="#loadProjects"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>loadProjects(filter: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>, sortDirection: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>, pageIndex: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank">number</a>, pageSize: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank">number</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="123"
                            class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:123</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                    <td>Default value</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>filter</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>

                                    <td>
                                        <code>&#x27;&#x27;</code>
                                    </td>

                                </tr>
                                <tr>
                                    <td>sortDirection</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>

                                    <td>
                                        <code>&#x27;asc&#x27;</code>
                                    </td>

                                </tr>
                                <tr>
                                    <td>pageIndex</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>

                                    <td>
                                        <code>0</code>
                                    </td>

                                </tr>
                                <tr>
                                    <td>pageSize</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>

                                    <td>
                                    </td>

                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="log"></a>
                    <span class="name">
                        <span class="modifier">Private</span>
                        <span ><b>log</b></span>
                        <a href="#log"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>log(message: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="159"
                            class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:159</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>Log a MessageService message with the MessageService</p>
</div>

                    <div class="io-description">
                        <b>Parameters :</b>
                        
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>message</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
</section>





    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Component, OnInit, ViewChild, AfterViewInit, ElementRef } from &#x27;@angular/core&#x27;;
import { CollectionViewer, DataSource} from &quot;@angular/cdk/collections&quot;;
import { ActivatedRoute } from &#x27;@angular/router&#x27;;
import { MatPaginator } from &#x27;@angular/material/paginator&#x27;;

import { BehaviorSubject, Observable, of, merge, fromEvent  } from &#x27;rxjs&#x27;;
import { catchError, finalize, tap, debounceTime, distinctUntilChanged  } from &#x27;rxjs/operators&#x27;;

import { ProjectAppService } from &#x27;../../services/project-app.service&#x27;;
import { Project } from &#x27;../../Project&#x27;;
import { MessageService } from &#x27;../../message.service&#x27;;
import { MatSort } from &#x27;@angular/material/sort&#x27;;

@Component({
  selector: &#x27;app-c-projects-table&#x27;,
  templateUrl: &#x27;./c-projects-table.component.html&#x27;,
  styleUrls: [&#x27;./c-projects-table.component.css&#x27;],
})
export class CProjectsTableComponent implements OnInit, AfterViewInit {

  project!: Project[];
  dataSource!: ProjectsDataSource;

  // Paginator
  displayedColumns&#x3D; [&quot;id&quot;, &quot;title&quot;, &quot;status&quot;, &quot;description&quot;];
  pageSizeOptions &#x3D; [3, 5, 10, 100];
  pageIndex:number;
  pageSize:number;
  length:number;


  @ViewChild(MatPaginator, {static:false}) paginator!: MatPaginator;
  @ViewChild(MatSort) sort!: MatSort;
  @ViewChild(&#x27;input&#x27;) input!: ElementRef;

  constructor(
      private projectAppService: ProjectAppService, 
      private messageService: MessageService,
      private route: ActivatedRoute
    ) {}

  ngOnInit() {
      this.project &#x3D; this.route.snapshot.data[&quot;project&quot;]
      this.dataSource &#x3D; new ProjectsDataSource(this.projectAppService,this.messageService);
      //this.dataSource.paginator &#x3D; this.paginator;
      //this.dataSource.getAllProjects()
      this.dataSource.loadProjects(&#x27;&#x27;, &#x27;asc&#x27;, 0, 3)
      console.log(&quot;ngOnInit()&quot;)
      console.log(this.dataSource)
  }

  ngAfterViewInit(): void {


      // server-side search
      fromEvent(this.input.nativeElement,&#x27;keyup&#x27;)
      .pipe(
          debounceTime(150),
          distinctUntilChanged(),
          tap(() &#x3D;&gt; {
              this.paginator.pageIndex &#x3D; 0;
              this.loadProjectsPage();
          })
      )
      .subscribe();

      // reset the paginator after sorting
      this.sort.sortChange.subscribe(() &#x3D;&gt; this.paginator.pageIndex &#x3D; 0);

      // on sort or paginate events, load a new page
      merge(this.sort.sortChange ,this.paginator.page)
          .pipe(
              tap(() &#x3D;&gt; this.loadProjectsPage())
          )
          .subscribe();
  }

  loadProjectsPage() {
      //this.dataSource.getAllProjects()
      
      this.dataSource.loadProjects(
          this.input.nativeElement.value,
          this.sort.direction,
          this.paginator.pageIndex,
          this.paginator.pageSize
      );
  }

  getProject(
    row&#x3D;&#x27;&#x27;
    ) {
      console.log(&quot;getProject&quot;)
      console.log(row)
  }

  

}

export class ProjectsDataSource implements DataSource&lt;Project&gt;{

  private projectsSubject &#x3D; new BehaviorSubject&lt;Project[]&gt;([]); 
  private loadingSubject &#x3D; new BehaviorSubject&lt;boolean&gt;(false);
  projects: Project[]&#x3D;[];

  public loading$ &#x3D; this.loadingSubject.asObservable();

  constructor(
    private projectService: ProjectAppService, 
    private messageService: MessageService
  ) {}

  connect(collectionViewer: CollectionViewer): Observable&lt;Project[]&gt; {
    return this.projectsSubject.asObservable();
  }

  disconnect(collectionViewer: CollectionViewer): void {
    this.projectsSubject.complete();
    this.loadingSubject.complete();
  }


  loadProjects(
      filter &#x3D; &#x27;&#x27;,
      sortDirection &#x3D; &#x27;asc&#x27;, 
      pageIndex &#x3D; 0, 
      pageSize: number
      ) {
    this.loadingSubject.next(true);

    this.projectService.findProjects(
          filter, 
          sortDirection,
          pageIndex, 
          pageSize
        ).pipe(
            catchError(
              error &#x3D;&gt; {
                this.log(&quot;Caught in CatchError. Returning []&quot;);
                console.log(&quot;loadProjects.pipe&quot;);
                return of([])
              }
              //() &#x3D;&gt; of([])
            ),
            finalize(() &#x3D;&gt; this.loadingSubject.next(false)),
            tap(_ &#x3D;&gt; this.log(&#x60;projects-material-table.components.ts: finalize&#x60;)),
        )
        .subscribe(
            project &#x3D;&gt; this.projectsSubject.next(project),
    );
  }  

  getAllProjects(): void {
    this.projectService.getAll()
    .subscribe(project &#x3D;&gt; this.projectsSubject.next(project));
  }

  /** Log a MessageService message with the MessageService */
  private log(message: string) {
    this.messageService.add(&#x60;MessageService: ${message}&#x60;);
  }
}</code></pre>
    </div>
</div>









                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> results matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

          <label class="dark-mode-switch">
               <input type="checkbox">
               <span class="slider">
                    <svg class="slider-icon" viewBox="0 0 24 24" fill="none" height="20" stroke="#000" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" width="20" xmlns="http://www.w3.org/2000/svg">
                    <path d="M21 12.79A9 9 0 1111.21 3 7 7 0 0021 12.79z"></path>
                    </svg>
               </span>
          </label>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'class';
            var COMPODOC_CURRENT_PAGE_URL = 'ProjectsDataSource-1.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>

       <script src="../js/menu-wc.js" defer></script>
       <script nomodule src="../js/menu-wc_es5.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
